/* Fo
 * fo-doc-pdflib.h: Wrapper for libfo output document
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-doc-pdflib.h,v 1.3 2003/07/22 13:12:32 tonygraham Exp $
 *
 * See Copying for the status of this software.
 */

#ifndef __FO_DOC_PDFLIB_H__
#define __FO_DOC_PDFLIB_H__

#include <libfo/fo-utils.h>
#include <libfo/fo-doc.h>

G_BEGIN_DECLS

typedef struct _FoDocPDFLIB      FoDocPDFLIB;
typedef struct _FoDocPDFLIBClass FoDocPDFLIBClass;

#define FO_TYPE_DOC_PDFLIB            (fo_doc_pdflib_get_type ())
#define FO_DOC_PDFLIB(object)         (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_DOC_PDFLIB, FoDocPDFLIB))
#define FO_DOC_PDFLIB_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_DOC_PDFLIB, FoDocPDFLIBClass))
#define FO_IS_DOC_PDFLIB(object)      (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_DOC_PDFLIB))
#define FO_IS_DOC_PDFLIB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_DOC_PDFLIB))
#define FO_DOC_PDFLIB_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_DOC_PDFLIB, FoDocPDFLIBClass))


GType   fo_doc_pdflib_get_type      (void);
FoDoc * fo_doc_pdflib_new           (void);

void    fo_doc_pdflib_set_parameter (FoDoc *fo_doc,
				     const gchar *key,
				     const gchar *value);
void    fo_doc_pdflib_set_value     (FoDoc       *fo_doc,
				     const gchar *key,
				     gfloat       value);
void    fo_doc_pdflib_set_info      (FoDoc       *fo_doc,
				     const gchar *key,
				     const gchar *value);

void    fo_doc_pdflib_open_file     (FoDoc       *fo_doc,
				     const gchar *filename,
				     GError     **error);

G_END_DECLS

#endif /* !__FO_DOC_PDFLIB_H__ */
